-- Default empty scheleton

function BrickTexture(bricks,morters,gr1,gr2)


local x2,y2,y3
local x, y, r, g, b
local r1,g1,b1,r2,g2,b2
r1,g1,b1 = decimal2rgb(gr1)
r2,g2,b2 = decimal2rgb(gr2)


for y = 0, height - 1 do
  for x = 0, width - 1 do
  
y2= math.mod (y,bricks/2)
y3=math.mod(y,bricks)  
x2=  math.mod (x,bricks)
if y3 > y2 then 
x2=math.mod (x+bricks/2,bricks)
else
x2=  math.mod (x,bricks)
end


if y3>(y2) then offset=bricks/2 else offset=0 end
if (x2> ( bricks-morters)) or (y2>(bricks/2)-morters) then
r=r2
g=g2
b=b2
else
r=r1
g=g1
b=b1
end
    

    set_rgb(x, y, r, g, b)
  end
  progress(y / height)
end

end



-----------------------------------------------------------------
-- The main part of the program where we setup the gui
-- and respond to the user
-----------------------------------------------------------------

Dog_SaveUndo()

--we are going to open a panel with a couple of controls on it.

--first, lets give the panel (window) a name.

GUI_SetCaption("Brick texture")

--we will now add a couple of controls for selecting color.

--make use of the "hex" function to convert hex colors into decimal numbers.
--if you're not familiar with colors represented in hex...
--hex is a way to represent numbers with 16 digits instead of ten (decimal)
--hex numbers are 0,1,2,3,4,5,6,7,8,9,a,b,c,d,e,f, for 0-16.
--to represent numbers between 0-255, we use two hex numbers.
--00 = 0.  FF = 255.
--to represent 24 bit color, we use 3 sets of hex numbers like...
--FF0000 would be bright blue.  0000FF would be bright red.

--lets add the conrols.
GUI_AddControl("TextLabel","Brick color",0,0)
h1 = GUI_AddControl("Colorbox", "", hex("2244F0"), 0, 0)
h2 = GUI_AddControl("Scroller", "Brick size", 100 ,2, 200)

GUI_AddControl("Line")
GUI_AddControl("TextLabel","Morter Color",0,0)
h3 = GUI_AddControl("Colorbox", "", hex("FFFFFF") ,0, 0)

h4 = GUI_AddControl("Scroller", "Morter size", 12,1, 100)
-- now that we've added all our controls, we can open the panel.

GUI_OpenPanel()

--this is our event loop.

repeat
idx, retval, retstr = GUI_WaitOnEvent()

g1,dummy=GUI_GetSettings(h1)
g2,dummy=GUI_GetSettings(h2)
g3,dummy=GUI_GetSettings(h3)
g4,dummy=GUI_GetSettings(h4)

--update the screen everytime the user clicks a control.
if idx >=0 then
BrickTexture(g2,g4,g1,g3)
Dog_Refresh()
end

until idx < 0


--example of getting the settengs of a specific control
--read any settings before closing the panel
--value, string = GUI_GetSettings(h1)

--always close the panel before exiting or it will stay around.

if idx == -2 then
Dog_RestoreUndo()
Dog_GetBuffer()
Dog_Refresh()
end

GUI_ClosePanel()