
function drawcircle( cx,cy,radius,feather,r,g,b )
--draw a antialiased or feathered circle example

 local r2,g2,b2
 local t ,x2,y2, al
 local x,y

 local x3,y3,x4,y4


x3=math.floor(cx-(radius/2)-feather)
y3=math.floor(cy-(radius/2)-feather)
x4=math.floor(cx+(radius/2)+feather)+1
y4=math.floor(cy+(radius/2)+feather)+1

for y = y3, y4  do
  for x =x3, x4 do

  x2=x-cx
  y2=y-cy

    t= math.sqrt ((x2*x2)+(y2*y2))

  if t <= radius/2 then
   r2=r
   g2=g
   b2=b
   else
   r2, g2, b2 = get_rgb(x, y)
   end

   if (t>radius/2) and (t<(( radius/2)+feather))  then
   --alpha
   al=(feather-(t-(radius/2)))/feather
     r2=(r*al)+(r2*(1-al))
     g2=(g*al)+(g2*(1-al))
     b2=(b*al)+(b2*(1-al))
   end

    set_rgb(x, y, r2, g2, b2)


  end
end

end





function cleanup(cx,cy,radius,feather)
--just cleans up the old image
--because we've been painting circles on it.
local x,y,r2,g2,b2
local x3,y3,x4,y4
x3=math.floor(cx-(radius/2)-feather)
y3=math.floor(cy-(radius/2)-feather)
x4=math.floor(cx+(radius/2)+feather)+1
y4=math.floor(cy+(radius/2)+feather)+1
for y =y3,y4 do
  for x = x3,x4 do
r2, g2, b2 = get_rgb(x, y)
set_rgb(x, y, r2, g2, b2)
  end
end
end




--start of gui


-- in case we 'Cancel',...
Dog_SaveUndo()

--you can set the caption of the panel at any time...
GUI_SetCaption("Feathered circle")

-- begin adding controls.

-- a scroller control

--a colorbox control (color picker)
h1 = GUI_AddControl("Colorbox", "Color", 50, 0, 100)
h2 = GUI_AddControl("line")
--
h3 = GUI_AddControl("TextLabel", "placement")
--when all controls are added, open the panel.

--a number control (numeric entry.  text is blocked)
h4 = GUI_AddControl("Number", "X", 100)
h5 = GUI_AddControl("Number", "Y", 100)
h6 = GUI_AddControl("Number", "Radius", 100)
h7 = GUI_AddControl("Number", "Feather", 2)

GUI_OpenPanel()
local idx, retval, retstr
local vx,vy,vrad,vfeather,vr,vg,vb,vv
--wait for an event to happen.
--If the returned value is <0 then OK or Cancel was pressed.
-- -1 of OK and -2 for Cancel.

vx=0
vy=0
vrad=0
vfeather=0
vr=0
vg=0
vb=0


repeat
idx, retval, retstr = GUI_WaitOnEvent()
--display the settings in the caption so we can see them.
--this is for testing only.
--GUI_SetCaption (idx)
--GUI_SetCaption (retval)
--GUI_SetCaption (retstr) -- beware setting a null in the caption...



if (idx>-1) then
cleanup(vx,vy,vrad,vfeather)--just removes the last dran circle
vx=GUI_GetSettings(h4)
vy=GUI_GetSettings(h5)
vrad=GUI_GetSettings(h6)
vfeather=GUI_GetSettings(h7)
vv=GUI_GetSettings(h1)
vr,vg,vb = decimal2rgb(vv)
   drawcircle ( vx,vy,vrad,vfeather,vr,vg,vb )
   Dog_Refresh()
end



until idx < 0
--if x=-2 then restoreundo
--example of getting the settengs of a specific control
--read any settings before closing the panel
--value, string = GUI_GetSettings(h1)


 GUI_ClosePanel()
 
-- if we pressed 'Cancel' restore original and show it
if idx == -2 then
  Dog_RestoreUndo()
  Dog_GetBuffer()
  Dog_Refresh()
end



