
--Mirror_GUI.lua



function DoMirror()
local x2,y2,x3,y3
local hw,hh
hw=math.floor((width-1)/2)
hh=math.floor((height-1)/2)

--let's convert coords to -1 to 1



--mirror left chunck to top

for y = 0, hh  do
  for x=0, width-1 do
   x2=(x-hw)/hw
   y2=(y-hh)/hh
    --make it come to a point
    if (x2 > y2) and (x2<  -y2) then
    --do the code
    x3=y2
    y3=x2
    x2=x3
    y2=y3    
    --convert back to normal coords
    x2=(x2+1)*hw
    y2=(y2+1)*hh
    x2=math.floor(x2)
    y2=math.floor(y2)
    r, g, b = get_rgb(x2, y2)
    set_rgb(x, y, r, g, b)
    end --end point

  end
end


--mirror left chunck to right

for x=hw, width-1 do
  for y = 0, height-1  do
   x2=(x-hw)/hw
   y2=(y-hh)/hh
    --make it come to a point
    if (x2 > y2) and (x2>  -y2) then
    --do the code
    x3=-x2
    y3=-y2
    x2=x3
    y2=y3    
    --convert back to normal coords
    x2=(x2+1)*hw
    y2=(y2+1)*hh
    x2=math.floor(x2)
    y2=math.floor(y2)
    r, g, b = get_rgb(x2, y2)
    set_rgb(x, y, r, g, b)
    end --end point

  end
end
--mirror left chunck to Bottom

for y = hh, height-1  do
  for x=0, width-1 do
   x2=(x-hw)/hw
   y2=(y-hh)/hh
    --make it come to a point
    if (x2 < y2) and (x2>  -y2) then
    --do the code
    x3=-y2
    y3=-x2
    x2=x3
    y2=y3    
    --convert back to normal coords
    x2=(x2+1)*hw
    y2=(y2+1)*hh
    x2=math.floor(x2)
    y2=math.floor(y2)
    r, g, b = get_rgb(x2, y2)
    set_rgb(x, y, r, g, b)
    end --end point

  end
end
end


--------------------------------------------


-- the main program.

local h1,h2,h3

Dog_SaveUndo()

GUI_SetCaption("Diagonal mirror")
--h1 = GUI_AddControl("Check", "Mirror h",1)
--h2 = GUI_AddControl("Check", "Mirror v", 0)
 --GUI_AddControl("Line")
h3=GUI_AddControl("Check","Animated",0)

GUI_OpenPanel()

DoMirror ()
Dog_Refresh()

--event loop.  Repeat until ok or cancel pressed (index of -1 or -2)

repeat
idx, retval, retstr = GUI_WaitOnEvent()

--check1,string=GUI_GetSettings(h1)
--check2,string=GUI_GetSettings(h2)
check3,string=GUI_GetSettings(h3)


if (idx>-1) then
DoMirror ()
Dog_Refresh()
end

until idx < 0 --repeat until


GUI_ClosePanel()

if idx == -1 then

--if animated
if check3 == 1 then
  --animate it
  Dog_RestoreUndo()
Dog_GetBuffer()
Dog_Refresh()
  local frame,endframe
  endframe=Dog_GetTotalFrames()

  Dog_GotoFrame(0)

    for frame=0,endframe-1 do
       Dog_GotoFrame(frame)
       DoMirror(check1,check2)
    end

  end --end animate

end -- end ok


if idx == -2 then
--Restore the image
Dog_RestoreUndo()
Dog_GetBuffer()
end



