
--Mirror_GUI.lua



function DoMirror(h,v)

hw=width/2
hh=height/2

for y = 0, height - 1 do
if v==1 then
 y2=hh-math.abs(y-hh)
else
 y2=y
end
  for x = 0, width - 1 do
    if h==1 then
     x2=hw-math.abs(x-hw)
    else
     x2=x
    end
    --
    r, g, b = get_rgb(x2, y2)
    set_rgb(x, y, r, g, b)
  end
  progress(y / height)
end
progress(0) --reset
end


--------------------------------------------


-- the main program.

local h1,h2,h3

Dog_SaveUndo()

GUI_SetCaption("Mirror")
h1 = GUI_AddControl("Check", "Mirror h",1)
h2 = GUI_AddControl("Check", "Mirror v", 0)
 GUI_AddControl("Line")
h3=GUI_AddControl("Check","Animated",0)

GUI_OpenPanel()

DoMirror (1,0)
Dog_Refresh()

--event loop.  Repeat until ok or cancel pressed (index of -1 or -2)

repeat
idx, retval, retstr = GUI_WaitOnEvent()

check1,string=GUI_GetSettings(h1)
check2,string=GUI_GetSettings(h2)
check3,string=GUI_GetSettings(h3)


if (idx>-1) then
DoMirror (check1,check2)
Dog_Refresh()
end

until idx < 0 --repeat until


GUI_ClosePanel()

if idx == -1 then

--if animated
if check3 == 1 then
  --animate it
  Dog_RestoreUndo()
Dog_GetBuffer()
Dog_Refresh()
  local frame,endframe
  endframe=Dog_GetTotalFrames()

  Dog_GotoFrame(0)

    for frame=0,endframe-1 do
       Dog_GotoFrame(frame)
       DoMirror(check1,check2)
    end

  end --end animate

end -- end ok


if idx == -2 then
--Restore the image
Dog_RestoreUndo()
Dog_GetBuffer()
end



